"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebPreview = void 0;

var _react = _interopRequireWildcard(require("react"));

var _IframePreview = _interopRequireDefault(require("./IframePreview.css"));

var _fetcher = _interopRequireDefault(require("../fetcher"));

var _client = _interopRequireDefault(require("part:@sanity/base/client"));

var _sanityPluginOnlyhtmlConnector = _interopRequireDefault(require("config:@onlyhtml/sanity-plugin-onlyhtml-connector"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var WebPreview = _ref => {
  var doc = _ref.document;
  var displayed = doc.displayed,
      draft = doc.draft;
  var slug = displayed.slug,
      _type = displayed._type;
  var url = 'http://localhost:8080'; // TODO change this url behaivour
  // https://docs.netlify.com/routing/redirects/

  if (slug && slug.current) {
    url += "/_".concat(_type);
  }

  var iframeRef = (0, _react.useRef)(undefined);

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      records = _useState2[0],
      setRecords = _useState2[1]; // create fetcher once per view


  var fetcher = (0, _react.useMemo)(() => {
    console.log('created fetcher!');
    return new _fetcher.default(_client.default.withConfig({
      apiVersion: '2021-02-02',
      useCdn: true,
      withCredentials: true
    }), _sanityPluginOnlyhtmlConnector.default.blocks);
  }, [url]);
  (0, _react.useEffect)(() => {
    fetcher.fetchRecords().then(r => {
      console.log('fetcher got records!', r);

      if (r === undefined) {
        console.warn('got undefined records from fetcher');
      }

      setRecords(r);
    }).catch(e => {
      console.error('got error while fetching', e);
    });
  }, [fetcher]);
  (0, _react.useEffect)(() => {
    if (!draft) {
      fetcher.fetchRecords().then(r => setRecords(r));
    }
  }, [draft]);

  var onIframeLoad = () => {
    console.log('iframe has loaded');
    renderRecords(iframeRef.current, records);
  };

  (0, _react.useEffect)(() => {
    console.log('records changed!', records, 'doc', draft);

    if (!iframeRef) {
      return;
    }

    _asyncToGenerator(function* () {
      var currentDoc = draft || displayed;
      var enrichedRecords = yield fetcher.enrichSanityDoc(records, currentDoc);
      console.log('got enriched records', enrichedRecords);
      renderRecords(iframeRef.current, enrichedRecords);
    })();
  }, [records, draft === null || draft === void 0 ? void 0 : draft._rev]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _IframePreview.default.componentWrapper
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _IframePreview.default.iframeContainer
  }, /*#__PURE__*/_react.default.createElement("iframe", {
    src: url,
    frameBorder: '0',
    ref: iframeRef,
    onLoad: onIframeLoad
  })));
};

exports.WebPreview = WebPreview;

function renderRecords(iframe, records) {
  if (!iframe || !records) {
    console.warn('was asked to render undefined iframe or records');
    return;
  }

  iframe.contentWindow.postMessage(records, '*');
  console.log('sent new records successfully');
}
//# sourceMappingURL=IframePreview.js.map