"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDefaultDocumentNode = void 0;

var _structureBuilder = _interopRequireDefault(require("@sanity/desk-tool/structure-builder"));

var _editIcon = _interopRequireDefault(require("part:@sanity/base/edit-icon"));

var _eyeIcon = _interopRequireDefault(require("part:@sanity/base/eye-icon"));

var _IframePreview = require("../panel/IframePreview");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getPreviewEditorNode = schemaType => {
  // Conditionally return a different configuration based on the schema type
  console.log('getEditorNode', schemaType);
  return _structureBuilder.default.document().schemaType(schemaType).views([_structureBuilder.default.view.form().icon(_editIcon.default), _structureBuilder.default.view.component(_IframePreview.WebPreview).title('Preview').icon(_eyeIcon.default).id('preview')]);
};

var getDefaultDocumentNode = _ref => {
  var schemaType = _ref.schemaType,
      documentId = _ref.documentId;
  return getPreviewEditorNode(schemaType);
};

exports.getDefaultDocumentNode = getDefaultDocumentNode;
//# sourceMappingURL=document_node.js.map